Index: src/intl-auto-encap-win32.c
===================================================================
RCS file: /pack/xemacscvs/XEmacs/xemacs/src/intl-auto-encap-win32.c,v
retrieving revision 1.10
diff -a -u -r1.10 intl-auto-encap-win32.c
--- src/intl-auto-encap-win32.c	2005/01/24 23:34:00	1.10
+++ src/intl-auto-encap-win32.c	2006/12/07 17:43:40
@@ -2403,385 +2495,456 @@
   else
     return StartDocA (arg1, (CONST DOCINFOA *) arg2);
 }
+
+/* Skipping GetObject because split-sized LOGFONT */
+
+BOOL
+qxeTextOut (HDC arg1, int arg2, int arg3, const Extbyte * arg4, int arg5)
+{
+  if (XEUNICODE_P)
+    return TextOutW (arg1, arg2, arg3, (LPCWSTR) arg4, arg5);
+  else
+    return TextOutA (arg1, arg2, arg3, (LPCSTR) arg4, arg5);
+}
+
+BOOL
+qxeExtTextOut (HDC arg1, int arg2, int arg3, UINT arg4, CONST RECT * arg5, const Extbyte * arg6, UINT arg7, CONST INT * arg8)
+{
+  if (XEUNICODE_P)
+    return ExtTextOutW (arg1, arg2, arg3, arg4, arg5, (LPCWSTR) arg6, arg7, arg8);
+  else
+    return ExtTextOutA (arg1, arg2, arg3, arg4, arg5, (LPCSTR) arg6, arg7, arg8);
+}
+
+BOOL
+qxePolyTextOut (HDC arg1, CONST POLYTEXTW * arg2, int arg3)
+{
+  if (XEUNICODE_P)
+    return PolyTextOutW (arg1, arg2, arg3);
+  else
+    return PolyTextOutA (arg1, (CONST POLYTEXTA *) arg2, arg3);
+}
+
+int
+qxeGetTextFace (HDC arg1, int arg2, Extbyte * arg3)
+{
+  if (XEUNICODE_P)
+    return GetTextFaceW (arg1, arg2, (LPWSTR) arg3);
+  else
+    return GetTextFaceA (arg1, arg2, (LPSTR) arg3);
+}
+
+DWORD
+qxeGetKerningPairs (HDC arg1, DWORD arg2, LPKERNINGPAIR arg3)
+{
+  if (XEUNICODE_P)
+    return GetKerningPairsW (arg1, arg2, arg3);
+  else
+    return GetKerningPairsA (arg1, arg2, arg3);
+}
+
+/* Error if GetLogColorSpace used: split-sized LPLOGCOLORSPACE; NT 4.0+ only */
+
+/* Error if CreateColorSpace used: split-sized LPLOGCOLORSPACE; NT 4.0+ only */
+
+/* Skipping GetICMProfile because NT 4.0+ only, error in Cygwin prototype */
+
+/* NOTE: NT 4.0+ only */
+BOOL
+qxeSetICMProfile (HDC arg1, Extbyte * arg2)
+{
+  if (XEUNICODE_P)
+    return SetICMProfileW (arg1, (LPWSTR) arg2);
+  else
+    return SetICMProfileA (arg1, (LPSTR) arg2);
+}
+
+/* NOTE: NT 4.0+ only */
+int
+qxeEnumICMProfiles (HDC arg1, ICMENUMPROCW arg2, LPARAM arg3)
+{
+  if (XEUNICODE_P)
+    return EnumICMProfilesW (arg1, arg2, arg3);
+  else
+    return EnumICMProfilesA (arg1, (ICMENUMPROCA) arg2, arg3);
+}
+
+/* Skipping UpdateICMRegKey because NT 4.0+ only, error in Cygwin prototype */
+
+/* Error if wglUseFontBitmaps used: causes link error */
+
+/* Error if wglUseFontOutlines used: causes link error */
+
+
+/*----------------------------------------------------------------------*/
+/*                       Processing file WINNLS.H                       */
+/*----------------------------------------------------------------------*/
+
+/* Error if GetCPInfoEx used: not used, not examined yet */
+
+/* Error if CompareString used: not used, not examined yet */
+
+/* Error if LCMapString used: not used, not examined yet */
+
+int
+qxeGetLocaleInfo (LCID Locale, LCTYPE LCType, Extbyte * lpLCData, int cchData)
+{
+  if (XEUNICODE_P)
+    return GetLocaleInfoW (Locale, LCType, (LPWSTR) lpLCData, cchData);
+  else
+    return GetLocaleInfoA (Locale, LCType, (LPSTR) lpLCData, cchData);
+}
+
+BOOL
+qxeSetLocaleInfo (LCID Locale, LCTYPE LCType, const Extbyte * lpLCData)
+{
+  if (XEUNICODE_P)
+    return SetLocaleInfoW (Locale, LCType, (LPCWSTR) lpLCData);
+  else
+    return SetLocaleInfoA (Locale, LCType, (LPCSTR) lpLCData);
+}
+
+/* Error if GetTimeFormat used: not used, not examined yet */
+
+/* Error if GetDateFormat used: not used, not examined yet */
+
+/* Error if GetNumberFormat used: not used, not examined yet */
+
+/* Error if GetCurrencyFormat used: not used, not examined yet */
+
+/* Error if EnumCalendarInfo used: not used, not examined yet */
+
+/* Error if EnumCalendarInfoEx used: not used, not examined yet */
+
+/* Error if EnumTimeFormats used: not used, not examined yet */
+
+/* Error if EnumDateFormats used: not used, not examined yet */
+
+/* Error if EnumDateFormatsEx used: not used, not examined yet */
+
+/* Error if GetStringTypeEx used: not used, not examined yet */
+
+/* Error if GetStringType used: no such fun; A and W versions have different nos. of args */
+
+/* Error if FoldString used: not used, not examined yet */
+
+/* Error if EnumSystemLocales used: not used, not examined yet */
+
+/* Error if EnumSystemCodePages used: not used, not examined yet */
+
+
+/*----------------------------------------------------------------------*/
+/*                       Processing file WINREG.H                       */
+/*----------------------------------------------------------------------*/
+
+/* Skipping RegConnectRegistry because error in Cygwin prototype */
 
-/* Skipping GetObject because split-sized LOGFONT */
+LONG
 
-BOOL
-qxeTextOut (HDC arg1, int arg2, int arg3, const Extbyte * arg4, int arg5)
+qxeRegCreateKey (HKEY hKey, const Extbyte * lpSubKey, PHKEY phkResult)
 {
   if (XEUNICODE_P)
-    return TextOutW (arg1, arg2, arg3, (LPCWSTR) arg4, arg5);
+    return RegCreateKeyW (hKey, (LPCWSTR) lpSubKey, phkResult);
   else
-    return TextOutA (arg1, arg2, arg3, (LPCSTR) arg4, arg5);
+    return RegCreateKeyA (hKey, (LPCSTR) lpSubKey, phkResult);
 }
 
-BOOL
-qxeExtTextOut (HDC arg1, int arg2, int arg3, UINT arg4, CONST RECT * arg5, const Extbyte * arg6, UINT arg7, CONST INT * arg8)
+LONG
+
+qxeRegCreateKeyEx (HKEY hKey, const Extbyte * lpSubKey, DWORD Reserved, Extbyte * lpClass, DWORD dwOptions, REGSAM samDesired, LPSECURITY_ATTRIBUTES lpSecurityAttributes, PHKEY phkResult, LPDWORD lpdwDisposition)
 {
   if (XEUNICODE_P)
-    return ExtTextOutW (arg1, arg2, arg3, arg4, arg5, (LPCWSTR) arg6, arg7, arg8);
+    return RegCreateKeyExW (hKey, (LPCWSTR) lpSubKey, Reserved, (LPWSTR) lpClass, dwOptions, samDesired, lpSecurityAttributes, phkResult, lpdwDisposition);
   else
-    return ExtTextOutA (arg1, arg2, arg3, arg4, arg5, (LPCSTR) arg6, arg7, arg8);
+    return RegCreateKeyExA (hKey, (LPCSTR) lpSubKey, Reserved, (LPSTR) lpClass, dwOptions, samDesired, lpSecurityAttributes, phkResult, lpdwDisposition);
 }
 
-BOOL
-qxePolyTextOut (HDC arg1, CONST POLYTEXTW * arg2, int arg3)
+LONG
+
+qxeRegDeleteKey (HKEY hKey, const Extbyte * lpSubKey)
 {
   if (XEUNICODE_P)
-    return PolyTextOutW (arg1, arg2, arg3);
+    return RegDeleteKeyW (hKey, (LPCWSTR) lpSubKey);
   else
-    return PolyTextOutA (arg1, (CONST POLYTEXTA *) arg2, arg3);
+    return RegDeleteKeyA (hKey, (LPCSTR) lpSubKey);
 }
 
-int
-qxeGetTextFace (HDC arg1, int arg2, Extbyte * arg3)
+LONG
+
+qxeRegDeleteValue (HKEY hKey, const Extbyte * lpValueName)
 {
   if (XEUNICODE_P)
-    return GetTextFaceW (arg1, arg2, (LPWSTR) arg3);
+    return RegDeleteValueW (hKey, (LPCWSTR) lpValueName);
   else
-    return GetTextFaceA (arg1, arg2, (LPSTR) arg3);
+    return RegDeleteValueA (hKey, (LPCSTR) lpValueName);
 }
 
-DWORD
-qxeGetKerningPairs (HDC arg1, DWORD arg2, LPKERNINGPAIR arg3)
+LONG
+
+qxeRegEnumKey (HKEY hKey, DWORD dwIndex, Extbyte * lpName, DWORD cbName)
 {
   if (XEUNICODE_P)
-    return GetKerningPairsW (arg1, arg2, arg3);
+    return RegEnumKeyW (hKey, dwIndex, (LPWSTR) lpName, cbName);
   else
-    return GetKerningPairsA (arg1, arg2, arg3);
+    return RegEnumKeyA (hKey, dwIndex, (LPSTR) lpName, cbName);
 }
-
-/* Error if GetLogColorSpace used: split-sized LPLOGCOLORSPACE; NT 4.0+ only */
-
-/* Error if CreateColorSpace used: split-sized LPLOGCOLORSPACE; NT 4.0+ only */
 
-/* Skipping GetICMProfile because NT 4.0+ only, error in Cygwin prototype */
+LONG
 
-/* NOTE: NT 4.0+ only */
-BOOL
-qxeSetICMProfile (HDC arg1, Extbyte * arg2)
+qxeRegEnumKeyEx (HKEY hKey, DWORD dwIndex, Extbyte * lpName, LPDWORD lpcbName, LPDWORD lpReserved, Extbyte * lpClass, LPDWORD lpcbClass, PFILETIME lpftLastWriteTime)
 {
   if (XEUNICODE_P)
-    return SetICMProfileW (arg1, (LPWSTR) arg2);
+    return RegEnumKeyExW (hKey, dwIndex, (LPWSTR) lpName, lpcbName, lpReserved, (LPWSTR) lpClass, lpcbClass, lpftLastWriteTime);
   else
-    return SetICMProfileA (arg1, (LPSTR) arg2);
+    return RegEnumKeyExA (hKey, dwIndex, (LPSTR) lpName, lpcbName, lpReserved, (LPSTR) lpClass, lpcbClass, lpftLastWriteTime);
 }
 
-/* NOTE: NT 4.0+ only */
-int
-qxeEnumICMProfiles (HDC arg1, ICMENUMPROCW arg2, LPARAM arg3)
+LONG
+
+qxeRegEnumValue (HKEY hKey, DWORD dwIndex, Extbyte * lpValueName, LPDWORD lpcbValueName, LPDWORD lpReserved, LPDWORD lpType, LPBYTE lpData, LPDWORD lpcbData)
 {
   if (XEUNICODE_P)
-    return EnumICMProfilesW (arg1, arg2, arg3);
+    return RegEnumValueW (hKey, dwIndex, (LPWSTR) lpValueName, lpcbValueName, lpReserved, lpType, lpData, lpcbData);
   else
-    return EnumICMProfilesA (arg1, (ICMENUMPROCA) arg2, arg3);
+    return RegEnumValueA (hKey, dwIndex, (LPSTR) lpValueName, lpcbValueName, lpReserved, lpType, lpData, lpcbData);
 }
-
-/* Skipping UpdateICMRegKey because NT 4.0+ only, error in Cygwin prototype */
-
-/* Error if wglUseFontBitmaps used: causes link error */
-
-/* Error if wglUseFontOutlines used: causes link error */
-
 
-/*----------------------------------------------------------------------*/
-/*                       Processing file SHLOBJ.H                       */
-/*----------------------------------------------------------------------*/
+LONG
 
-BOOL
-qxeSHGetPathFromIDList (LPCITEMIDLIST pidl, Extbyte * pszPath)
+qxeRegLoadKey (HKEY hKey, const Extbyte * lpSubKey, const Extbyte * lpFile)
 {
   if (XEUNICODE_P)
-    return SHGetPathFromIDListW (pidl, (LPWSTR) pszPath);
+    return RegLoadKeyW (hKey, (LPCWSTR) lpSubKey, (LPCWSTR) lpFile);
   else
-    return SHGetPathFromIDListA (pidl, (LPSTR) pszPath);
+    return RegLoadKeyA (hKey, (LPCSTR) lpSubKey, (LPCSTR) lpFile);
 }
-
-/* Skipping SHGetSpecialFolderPath because error in Cygwin prototype, missing from Cygwin libraries */
-
-/* Skipping SHBrowseForFolder because need to intercept callback for SendMessage */
-
-/* Skipping SHGetDataFromIDList because split-sized WIN32_FIND_DATA or split-simple NETRESOURCE, missing from Cygwin libraries */
-
 
-/*----------------------------------------------------------------------*/
-/*                      Processing file COMMDLG.H                       */
-/*----------------------------------------------------------------------*/
+LONG
 
-BOOL  
-qxeGetOpenFileName (LPOPENFILENAMEW arg1)
+qxeRegOpenKey (HKEY hKey, const Extbyte * lpSubKey, PHKEY phkResult)
 {
   if (XEUNICODE_P)
-    return GetOpenFileNameW (arg1);
+    return RegOpenKeyW (hKey, (LPCWSTR) lpSubKey, phkResult);
   else
-    return GetOpenFileNameA ((LPOPENFILENAMEA) arg1);
+    return RegOpenKeyA (hKey, (LPCSTR) lpSubKey, phkResult);
 }
 
-BOOL  
-qxeGetSaveFileName (LPOPENFILENAMEW arg1)
+LONG
+
+qxeRegOpenKeyEx (HKEY hKey, const Extbyte * lpSubKey, DWORD ulOptions, REGSAM samDesired, PHKEY phkResult)
 {
   if (XEUNICODE_P)
-    return GetSaveFileNameW (arg1);
+    return RegOpenKeyExW (hKey, (LPCWSTR) lpSubKey, ulOptions, samDesired, phkResult);
   else
-    return GetSaveFileNameA ((LPOPENFILENAMEA) arg1);
+    return RegOpenKeyExA (hKey, (LPCSTR) lpSubKey, ulOptions, samDesired, phkResult);
 }
 
-short 
-qxeGetFileTitle (const Extbyte * arg1, Extbyte * arg2, WORD arg3)
+LONG
+
+qxeRegQueryInfoKey (HKEY hKey, Extbyte * lpClass, LPDWORD lpcbClass, LPDWORD lpReserved, LPDWORD lpcSubKeys, LPDWORD lpcbMaxSubKeyLen, LPDWORD lpcbMaxClassLen, LPDWORD lpcValues, LPDWORD lpcbMaxValueNameLen, LPDWORD lpcbMaxValueLen, LPDWORD lpcbSecurityDescriptor, PFILETIME lpftLastWriteTime)
 {
   if (XEUNICODE_P)
-    return GetFileTitleW ((LPCWSTR) arg1, (LPWSTR) arg2, arg3);
+    return RegQueryInfoKeyW (hKey, (LPWSTR) lpClass, lpcbClass, lpReserved, lpcSubKeys, lpcbMaxSubKeyLen, lpcbMaxClassLen, lpcValues, lpcbMaxValueNameLen, lpcbMaxValueLen, lpcbSecurityDescriptor, lpftLastWriteTime);
   else
-    return GetFileTitleA ((LPCSTR) arg1, (LPSTR) arg2, arg3);
+    return RegQueryInfoKeyA (hKey, (LPSTR) lpClass, lpcbClass, lpReserved, lpcSubKeys, lpcbMaxSubKeyLen, lpcbMaxClassLen, lpcValues, lpcbMaxValueNameLen, lpcbMaxValueLen, lpcbSecurityDescriptor, lpftLastWriteTime);
 }
 
-BOOL  
-qxeChooseColor (LPCHOOSECOLORW arg1)
+LONG
+
+qxeRegQueryValue (HKEY hKey, const Extbyte * lpSubKey, Extbyte * lpValue, PLONG lpcbValue)
 {
   if (XEUNICODE_P)
-    return ChooseColorW (arg1);
+    return RegQueryValueW (hKey, (LPCWSTR) lpSubKey, (LPWSTR) lpValue, lpcbValue);
   else
-    return ChooseColorA ((LPCHOOSECOLORA) arg1);
+    return RegQueryValueA (hKey, (LPCSTR) lpSubKey, (LPSTR) lpValue, lpcbValue);
 }
 
-HWND  
-qxeFindText (LPFINDREPLACEW arg1)
+LONG
+
+qxeRegQueryMultipleValues (HKEY hKey, PVALENTW val_list, DWORD num_vals, Extbyte * lpValueBuf, LPDWORD ldwTotsize)
 {
   if (XEUNICODE_P)
-    return FindTextW (arg1);
+    return RegQueryMultipleValuesW (hKey, val_list, num_vals, (LPWSTR) lpValueBuf, ldwTotsize);
   else
-    return FindTextA ((LPFINDREPLACEA) arg1);
+    return RegQueryMultipleValuesA (hKey, (PVALENTA) val_list, num_vals, (LPSTR) lpValueBuf, ldwTotsize);
 }
 
-HWND  
-qxeReplaceText (LPFINDREPLACEW arg1)
+LONG
+
+qxeRegQueryValueEx (HKEY hKey, const Extbyte * lpValueName, LPDWORD lpReserved, LPDWORD lpType, LPBYTE lpData, LPDWORD lpcbData)
 {
   if (XEUNICODE_P)
-    return ReplaceTextW (arg1);
+    return RegQueryValueExW (hKey, (LPCWSTR) lpValueName, lpReserved, lpType, lpData, lpcbData);
   else
-    return ReplaceTextA ((LPFINDREPLACEA) arg1);
+    return RegQueryValueExA (hKey, (LPCSTR) lpValueName, lpReserved, lpType, lpData, lpcbData);
 }
-
-/* Error if AfxReplaceText used: mac only */
-
-/* Error if ChooseFont used: split-sized LPLOGFONT in LPCHOOSEFONT */
-
-/* Skipping PrintDlg because LPPRINTDLG with split-sized DEVMODE handle */
-
-/* Skipping PageSetupDlg because LPPAGESETUPDLG with split-sized DEVMODE handle */
-
-
-/*----------------------------------------------------------------------*/
-/*                        Processing file IMM.H                         */
-/*----------------------------------------------------------------------*/
 
-#if defined (HAVE_MS_WINDOWS)
+LONG
 
-HKL
-qxeImmInstallIME (const Extbyte * lpszIMEFileName, const Extbyte * lpszLayoutText)
+qxeRegReplaceKey (HKEY hKey, const Extbyte * lpSubKey, const Extbyte * lpNewFile, const Extbyte * lpOldFile)
 {
   if (XEUNICODE_P)
-    return ImmInstallIMEW ((LPCWSTR) lpszIMEFileName, (LPCWSTR) lpszLayoutText);
+    return RegReplaceKeyW (hKey, (LPCWSTR) lpSubKey, (LPCWSTR) lpNewFile, (LPCWSTR) lpOldFile);
   else
-    return ImmInstallIMEA ((LPCSTR) lpszIMEFileName, (LPCSTR) lpszLayoutText);
+    return RegReplaceKeyA (hKey, (LPCSTR) lpSubKey, (LPCSTR) lpNewFile, (LPCSTR) lpOldFile);
 }
 
-#endif /* defined (HAVE_MS_WINDOWS) */
-
-#if defined (HAVE_MS_WINDOWS)
+LONG
 
-UINT
-qxeImmGetDescription (HKL arg1, Extbyte * arg2, UINT uBufLen)
+qxeRegRestoreKey (HKEY hKey, const Extbyte * lpFile, DWORD dwFlags)
 {
   if (XEUNICODE_P)
-    return ImmGetDescriptionW (arg1, (LPWSTR) arg2, uBufLen);
+    return RegRestoreKeyW (hKey, (LPCWSTR) lpFile, dwFlags);
   else
-    return ImmGetDescriptionA (arg1, (LPSTR) arg2, uBufLen);
+    return RegRestoreKeyA (hKey, (LPCSTR) lpFile, dwFlags);
 }
-
-#endif /* defined (HAVE_MS_WINDOWS) */
 
-#if defined (HAVE_MS_WINDOWS)
+LONG
 
-UINT
-qxeImmGetIMEFileName (HKL arg1, Extbyte * arg2, UINT uBufLen)
+qxeRegSaveKey (HKEY hKey, const Extbyte * lpFile, LPSECURITY_ATTRIBUTES lpSecurityAttributes)
 {
   if (XEUNICODE_P)
-    return ImmGetIMEFileNameW (arg1, (LPWSTR) arg2, uBufLen);
+    return RegSaveKeyW (hKey, (LPCWSTR) lpFile, lpSecurityAttributes);
   else
-    return ImmGetIMEFileNameA (arg1, (LPSTR) arg2, uBufLen);
+    return RegSaveKeyA (hKey, (LPCSTR) lpFile, lpSecurityAttributes);
 }
 
-#endif /* defined (HAVE_MS_WINDOWS) */
-
-#if defined (HAVE_MS_WINDOWS)
-
 LONG
-qxeImmGetCompositionString (HIMC arg1, DWORD arg2, LPVOID arg3, DWORD arg4)
+
+qxeRegSetValue (HKEY hKey, const Extbyte * lpSubKey, DWORD dwType, const Extbyte * lpData, DWORD cbData)
 {
   if (XEUNICODE_P)
-    return ImmGetCompositionStringW (arg1, arg2, arg3, arg4);
+    return RegSetValueW (hKey, (LPCWSTR) lpSubKey, dwType, (LPCWSTR) lpData, cbData);
   else
-    return ImmGetCompositionStringA (arg1, arg2, arg3, arg4);
+    return RegSetValueA (hKey, (LPCSTR) lpSubKey, dwType, (LPCSTR) lpData, cbData);
 }
-
-#endif /* defined (HAVE_MS_WINDOWS) */
 
-#if defined (HAVE_MS_WINDOWS)
+LONG
 
-DWORD
-qxeImmGetCandidateListCount (HIMC arg1, LPDWORD lpdwListCount)
+qxeRegSetValueEx (HKEY hKey, const Extbyte * lpValueName, DWORD Reserved, DWORD dwType, CONST BYTE* lpData, DWORD cbData)
 {
   if (XEUNICODE_P)
-    return ImmGetCandidateListCountW (arg1, lpdwListCount);
+    return RegSetValueExW (hKey, (LPCWSTR) lpValueName, Reserved, dwType, lpData, cbData);
   else
-    return ImmGetCandidateListCountA (arg1, lpdwListCount);
+    return RegSetValueExA (hKey, (LPCSTR) lpValueName, Reserved, dwType, lpData, cbData);
 }
 
-#endif /* defined (HAVE_MS_WINDOWS) */
-
-#if defined (HAVE_MS_WINDOWS)
+LONG
 
-DWORD
-qxeImmGetCandidateList (HIMC arg1, DWORD deIndex, LPCANDIDATELIST arg3, DWORD dwBufLen)
+qxeRegUnLoadKey (HKEY hKey, const Extbyte * lpSubKey)
 {
   if (XEUNICODE_P)
-    return ImmGetCandidateListW (arg1, deIndex, arg3, dwBufLen);
+    return RegUnLoadKeyW (hKey, (LPCWSTR) lpSubKey);
   else
-    return ImmGetCandidateListA (arg1, deIndex, arg3, dwBufLen);
+    return RegUnLoadKeyA (hKey, (LPCSTR) lpSubKey);
 }
-
-#endif /* defined (HAVE_MS_WINDOWS) */
 
-#if defined (HAVE_MS_WINDOWS)
+BOOL
 
-DWORD
-qxeImmGetGuideLine (HIMC arg1, DWORD dwIndex, Extbyte * arg3, DWORD dwBufLen)
+qxeInitiateSystemShutdown (Extbyte * lpMachineName, Extbyte * lpMessage, DWORD dwTimeout, BOOL bForceAppsClosed, BOOL bRebootAfterShutdown)
 {
   if (XEUNICODE_P)
-    return ImmGetGuideLineW (arg1, dwIndex, (LPWSTR) arg3, dwBufLen);
+    return InitiateSystemShutdownW ((LPWSTR) lpMachineName, (LPWSTR) lpMessage, dwTimeout, bForceAppsClosed, bRebootAfterShutdown);
   else
-    return ImmGetGuideLineA (arg1, dwIndex, (LPSTR) arg3, dwBufLen);
+    return InitiateSystemShutdownA ((LPSTR) lpMachineName, (LPSTR) lpMessage, dwTimeout, bForceAppsClosed, bRebootAfterShutdown);
 }
 
-#endif /* defined (HAVE_MS_WINDOWS) */
-
-#if defined (HAVE_MS_WINDOWS)
-
-/* Skipping ImmGetCompositionFont because split-sized LOGFONT */
-
-#endif /* defined (HAVE_MS_WINDOWS) */
-
-#if defined (HAVE_MS_WINDOWS)
-
-/* Skipping ImmSetCompositionFont because split-sized LOGFONT */
-
-#endif /* defined (HAVE_MS_WINDOWS) */
-
-#if defined (HAVE_MS_WINDOWS)
-
-/* NOTE: // split-simple REGISTERWORD */
 BOOL
-qxeImmConfigureIME (HKL arg1, HWND arg2, DWORD arg3, LPVOID arg4)
+
+qxeAbortSystemShutdown (Extbyte * lpMachineName)
 {
   if (XEUNICODE_P)
-    return ImmConfigureIMEW (arg1, arg2, arg3, arg4);
+    return AbortSystemShutdownW ((LPWSTR) lpMachineName);
   else
-    return ImmConfigureIMEA (arg1, arg2, arg3, arg4);
+    return AbortSystemShutdownA ((LPSTR) lpMachineName);
 }
 
-#endif /* defined (HAVE_MS_WINDOWS) */
 
-#if defined (HAVE_MS_WINDOWS)
+/*----------------------------------------------------------------------*/
+/*                      Processing file COMMDLG.H                       */
+/*----------------------------------------------------------------------*/
 
-/* NOTE: // strings of various sorts */
-LRESULT
-qxeImmEscape (HKL arg1, HIMC arg2, UINT arg3, LPVOID arg4)
+BOOL  
+qxeGetOpenFileName (LPOPENFILENAMEW arg1)
 {
   if (XEUNICODE_P)
-    return ImmEscapeW (arg1, arg2, arg3, arg4);
+    return GetOpenFileNameW (arg1);
   else
-    return ImmEscapeA (arg1, arg2, arg3, arg4);
+    return GetOpenFileNameA ((LPOPENFILENAMEA) arg1);
 }
-
-#endif /* defined (HAVE_MS_WINDOWS) */
-
-#if defined (HAVE_MS_WINDOWS)
 
-DWORD
-qxeImmGetConversionList (HKL arg1, HIMC arg2, const Extbyte * arg3, LPCANDIDATELIST arg4, DWORD dwBufLen, UINT uFlag)
+BOOL  
+qxeGetSaveFileName (LPOPENFILENAMEW arg1)
 {
   if (XEUNICODE_P)
-    return ImmGetConversionListW (arg1, arg2, (LPCWSTR) arg3, arg4, dwBufLen, uFlag);
+    return GetSaveFileNameW (arg1);
   else
-    return ImmGetConversionListA (arg1, arg2, (LPCSTR) arg3, arg4, dwBufLen, uFlag);
+    return GetSaveFileNameA ((LPOPENFILENAMEA) arg1);
 }
 
-#endif /* defined (HAVE_MS_WINDOWS) */
-
-#if defined (HAVE_MS_WINDOWS)
-
-BOOL
-qxeImmIsUIMessage (HWND arg1, UINT arg2, WPARAM arg3, LPARAM arg4)
+short 
+qxeGetFileTitle (const Extbyte * arg1, Extbyte * arg2, WORD arg3)
 {
   if (XEUNICODE_P)
-    return ImmIsUIMessageW (arg1, arg2, arg3, arg4);
+    return GetFileTitleW ((LPCWSTR) arg1, (LPWSTR) arg2, arg3);
   else
-    return ImmIsUIMessageA (arg1, arg2, arg3, arg4);
+    return GetFileTitleA ((LPCSTR) arg1, (LPSTR) arg2, arg3);
 }
-
-#endif /* defined (HAVE_MS_WINDOWS) */
-
-#if defined (HAVE_MS_WINDOWS)
 
-BOOL
-qxeImmRegisterWord (HKL arg1, const Extbyte * lpszReading, DWORD arg3, const Extbyte * lpszRegister)
+BOOL  
+qxeChooseColor (LPCHOOSECOLORW arg1)
 {
   if (XEUNICODE_P)
-    return ImmRegisterWordW (arg1, (LPCWSTR) lpszReading, arg3, (LPCWSTR) lpszRegister);
+    return ChooseColorW (arg1);
   else
-    return ImmRegisterWordA (arg1, (LPCSTR) lpszReading, arg3, (LPCSTR) lpszRegister);
+    return ChooseColorA ((LPCHOOSECOLORA) arg1);
 }
 
-#endif /* defined (HAVE_MS_WINDOWS) */
-
-#if defined (HAVE_MS_WINDOWS)
+HWND  
+qxeFindText (LPFINDREPLACEW arg1)
+{
+  if (XEUNICODE_P)
+    return FindTextW (arg1);
+  else
+    return FindTextA ((LPFINDREPLACEA) arg1);
+}
 
-BOOL
-qxeImmUnregisterWord (HKL arg1, const Extbyte * lpszReading, DWORD arg3, const Extbyte * lpszUnregister)
+HWND  
+qxeReplaceText (LPFINDREPLACEW arg1)
 {
   if (XEUNICODE_P)
-    return ImmUnregisterWordW (arg1, (LPCWSTR) lpszReading, arg3, (LPCWSTR) lpszUnregister);
+    return ReplaceTextW (arg1);
   else
-    return ImmUnregisterWordA (arg1, (LPCSTR) lpszReading, arg3, (LPCSTR) lpszUnregister);
+    return ReplaceTextA ((LPFINDREPLACEA) arg1);
 }
 
-#endif /* defined (HAVE_MS_WINDOWS) */
+/* Error if AfxReplaceText used: mac only */
 
-#if defined (HAVE_MS_WINDOWS)
+/* Error if ChooseFont used: split-sized LPLOGFONT in LPCHOOSEFONT */
 
-/* Error if ImmGetRegisterWordStyle used: split-sized STYLEBUF */
+/* Skipping PrintDlg because LPPRINTDLG with split-sized DEVMODE handle */
 
-#endif /* defined (HAVE_MS_WINDOWS) */
+/* Skipping PageSetupDlg because LPPAGESETUPDLG with split-sized DEVMODE handle */
 
-#if defined (HAVE_MS_WINDOWS)
 
-UINT
-qxeImmEnumRegisterWord (HKL arg1, REGISTERWORDENUMPROCW arg2, const Extbyte * lpszReading, DWORD arg4, const Extbyte * lpszRegister, LPVOID arg6)
+/*----------------------------------------------------------------------*/
+/*                       Processing file SHLOBJ.H                       */
+/*----------------------------------------------------------------------*/
+
+BOOL
+qxeSHGetPathFromIDList (LPCITEMIDLIST pidl, Extbyte * pszPath)
 {
   if (XEUNICODE_P)
-    return ImmEnumRegisterWordW (arg1, arg2, (LPCWSTR) lpszReading, arg4, (LPCWSTR) lpszRegister, arg6);
+    return SHGetPathFromIDListW (pidl, (LPWSTR) pszPath);
   else
-    return ImmEnumRegisterWordA (arg1, (REGISTERWORDENUMPROCA) arg2, (LPCSTR) lpszReading, arg4, (LPCSTR) lpszRegister, arg6);
+    return SHGetPathFromIDListA (pidl, (LPSTR) pszPath);
 }
 
-#endif /* defined (HAVE_MS_WINDOWS) */
-
-#if defined (HAVE_MS_WINDOWS)
+/* Skipping SHGetSpecialFolderPath because error in Cygwin prototype, missing from Cygwin libraries */
 
-/* Error if ImmGetImeMenuItems used: split-sized IMEMENUITEMINFO */
+/* Skipping SHBrowseForFolder because need to intercept callback for SendMessage */
 
-#endif /* defined (HAVE_MS_WINDOWS) */
+/* Skipping SHGetDataFromIDList because split-sized WIN32_FIND_DATA or split-simple NETRESOURCE, missing from Cygwin libraries */
 
 
 /*----------------------------------------------------------------------*/
@@ -3132,6 +3295,12 @@
     return FindResourceExA (hModule, (LPCSTR) lpType, (LPCSTR) lpName, wLanguage);
 }
 
+/* Skipping EnumResourceTypes because different prototypes in VC6 and VC7 */
+
+/* Skipping EnumResourceNames because different prototypes in VC6 and VC7 */
+
+/* Skipping EnumResourceLanguages because different prototypes in VC6 and VC7 */
+
 HANDLE
 qxeBeginUpdateResource (const Extbyte * pFileName, BOOL bDeleteExistingResources)
 {
@@ -3933,158 +4102,15 @@
 
 
 /*----------------------------------------------------------------------*/
-/*                      Processing file MMSYSTEM.H                      */
+/*                       Processing file ACLAPI.h                       */
 /*----------------------------------------------------------------------*/
-
-BOOL
-qxesndPlaySound (const Extbyte * pszSound, UINT fuSound)
-{
-  if (XEUNICODE_P)
-    return sndPlaySoundW ((LPCWSTR) pszSound, fuSound);
-  else
-    return sndPlaySoundA ((LPCSTR) pszSound, fuSound);
-}
-
-BOOL
-qxePlaySound (const Extbyte * pszSound, HMODULE hmod, DWORD fdwSound)
-{
-  if (XEUNICODE_P)
-    return PlaySoundW ((LPCWSTR) pszSound, hmod, fdwSound);
-  else
-    return PlaySoundA ((LPCSTR) pszSound, hmod, fdwSound);
-}
-
-/* Error if waveOutGetDevCaps used: split-sized LPWAVEOUTCAPS */
 
-MMRESULT
-qxewaveOutGetErrorText (MMRESULT mmrError, Extbyte * pszText, UINT cchText)
-{
-  if (XEUNICODE_P)
-    return waveOutGetErrorTextW (mmrError, (LPWSTR) pszText, cchText);
-  else
-    return waveOutGetErrorTextA (mmrError, (LPSTR) pszText, cchText);
-}
-
-/* Error if waveInGetDevCaps used: split-sized LPWAVEINCAPS */
-
-MMRESULT
-qxewaveInGetErrorText (MMRESULT mmrError, Extbyte * pszText, UINT cchText)
-{
-  if (XEUNICODE_P)
-    return waveInGetErrorTextW (mmrError, (LPWSTR) pszText, cchText);
-  else
-    return waveInGetErrorTextA (mmrError, (LPSTR) pszText, cchText);
-}
-
-/* Error if midiOutGetDevCaps used: split-sized LPMIDIOUTCAPS */
-
-MMRESULT
-qxemidiOutGetErrorText (MMRESULT mmrError, Extbyte * pszText, UINT cchText)
-{
-  if (XEUNICODE_P)
-    return midiOutGetErrorTextW (mmrError, (LPWSTR) pszText, cchText);
-  else
-    return midiOutGetErrorTextA (mmrError, (LPSTR) pszText, cchText);
-}
-
-/* Error if midiInGetDevCaps used: split-sized LPMIDIOUTCAPS */
-
-MMRESULT
-qxemidiInGetErrorText (MMRESULT mmrError, Extbyte * pszText, UINT cchText)
-{
-  if (XEUNICODE_P)
-    return midiInGetErrorTextW (mmrError, (LPWSTR) pszText, cchText);
-  else
-    return midiInGetErrorTextA (mmrError, (LPSTR) pszText, cchText);
-}
-
-/* Error if auxGetDevCaps used: split-sized LPAUXCAPS */
-
-/* Error if mixerGetDevCaps used: split-sized LPMIXERCAPS */
-
-/* Error if mixerGetLineInfo used: split-sized LPMIXERLINE */
-
-/* Error if mixerGetLineControls used: split-sized LPMIXERCONTROL */
-
-/* Error if mixerGetControlDetails used: split-sized LPMIXERCONTROL in LPMIXERLINECONTROLS in LPMIXERCONTROLDETAILS */
-
-/* Error if joyGetDevCaps used: split-sized LPJOYCAPS */
-
-FOURCC
-qxemmioStringToFOURCC (const Extbyte * sz, UINT uFlags)
-{
-  if (XEUNICODE_P)
-    return mmioStringToFOURCCW ((LPCWSTR) sz, uFlags);
-  else
-    return mmioStringToFOURCCA ((LPCSTR) sz, uFlags);
-}
-
-LPMMIOPROC
-qxemmioInstallIOProc (FOURCC fccIOProc, LPMMIOPROC pIOProc, DWORD dwFlags)
-{
-  if (XEUNICODE_P)
-    return mmioInstallIOProcW (fccIOProc, pIOProc, dwFlags);
-  else
-    return mmioInstallIOProcA (fccIOProc, pIOProc, dwFlags);
-}
-
-HMMIO
-qxemmioOpen (Extbyte * pszFileName, LPMMIOINFO pmmioinfo, DWORD fdwOpen)
-{
-  if (XEUNICODE_P)
-    return mmioOpenW ((LPWSTR) pszFileName, pmmioinfo, fdwOpen);
-  else
-    return mmioOpenA ((LPSTR) pszFileName, pmmioinfo, fdwOpen);
-}
-
-MMRESULT
-qxemmioRename (const Extbyte * pszFileName, const Extbyte * pszNewFileName, LPCMMIOINFO pmmioinfo, DWORD fdwRename)
-{
-  if (XEUNICODE_P)
-    return mmioRenameW ((LPCWSTR) pszFileName, (LPCWSTR) pszNewFileName, pmmioinfo, fdwRename);
-  else
-    return mmioRenameA ((LPCSTR) pszFileName, (LPCSTR) pszNewFileName, pmmioinfo, fdwRename);
-}
-
-MCIERROR
-qxemciSendCommand (MCIDEVICEID mciId, UINT uMsg, DWORD dwParam1, DWORD dwParam2)
-{
-  if (XEUNICODE_P)
-    return mciSendCommandW (mciId, uMsg, dwParam1, dwParam2);
-  else
-    return mciSendCommandA (mciId, uMsg, dwParam1, dwParam2);
-}
-
-MCIERROR
-qxemciSendString (const Extbyte * lpstrCommand, Extbyte * lpstrReturnString, UINT uReturnLength, HWND hwndCallback)
-{
-  if (XEUNICODE_P)
-    return mciSendStringW ((LPCWSTR) lpstrCommand, (LPWSTR) lpstrReturnString, uReturnLength, hwndCallback);
-  else
-    return mciSendStringA ((LPCSTR) lpstrCommand, (LPSTR) lpstrReturnString, uReturnLength, hwndCallback);
-}
-
-MCIDEVICEID
-qxemciGetDeviceID (const Extbyte * pszDevice)
-{
-  if (XEUNICODE_P)
-    return mciGetDeviceIDW ((LPCWSTR) pszDevice);
-  else
-    return mciGetDeviceIDA ((LPCSTR) pszDevice);
-}
-
-#if !defined (MINGW)
-
-/* Error if mciGetDeviceIDFromElementID used: missing from Win98se version of ADVAPI32.dll */
-
-#endif /* !defined (MINGW) */
-
-BOOL
-qxemciGetErrorString (MCIERROR mcierr, Extbyte * pszText, UINT cchText)
+DWORD
+qxeGetNamedSecurityInfo (IN  Extbyte * pObjectName, IN  SE_OBJECT_TYPE ObjectType, IN  SECURITY_INFORMATION SecurityInfo, OUT PSID                 * ppsidOowner, OUT PSID                 * ppsidGroup, OUT PACL                 * ppDacl, OUT PACL                 * ppSacl, OUT PSECURITY_DESCRIPTOR * ppSecurityDescriptor)
 {
   if (XEUNICODE_P)
-    return mciGetErrorStringW (mcierr, (LPWSTR) pszText, cchText);
+    return GetNamedSecurityInfoW ((IN  LPWSTR) pObjectName, ObjectType, SecurityInfo, ppsidOowner, ppsidGroup, ppDacl, ppSacl, ppSecurityDescriptor);
   else
-    return mciGetErrorStringA (mcierr, (LPSTR) pszText, cchText);
+    return GetNamedSecurityInfoA ((IN  LPSTR) pObjectName, ObjectType, SecurityInfo, ppsidOowner, ppsidGroup, ppDacl, ppSacl, ppSecurityDescriptor);
 }
 
